Index: /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Evaluators/SymbolicTimeSeriesPrognosisScaledNormalizedFractionalDistanceEvaluator.cs
===================================================================
--- /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Evaluators/SymbolicTimeSeriesPrognosisScaledNormalizedFractionalDistanceEvaluator.cs	(revision 5275)
+++ /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Evaluators/SymbolicTimeSeriesPrognosisScaledNormalizedFractionalDistanceEvaluator.cs	(revision 5275)
@@ -0,0 +1,184 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis.SupportVectorMachine;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.DataAnalysis.Evaluators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Optimization;
+using HeuristicLab.Operators;
+using HeuristicLab.Problems.DataAnalysis.Regression.Symbolic;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using System.Collections.Generic;
+using HeuristicLab.Problems.DataAnalysis.Regression;
+using HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis.Symbolic.Interfaces;
+using HeuristicLab.Problems.DataAnalysis.MultiVariate.Evaluators;
+
+namespace HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis.Symbolic.Evaluators {
+  [Item("SymbolicTimeSeriesPrognosisScaledNormalizedFractionalDistanceEvaluator", "")]
+  [StorableClass]
+  public class SymbolicTimeSeriesPrognosisScaledNormalizedFractionalDistanceEvaluator : SymbolicTimeSeriesPrognosisEvaluator {
+    public ValueParameter<DoubleValue> DimensionParameter {
+      get { return (ValueParameter<DoubleValue>)Parameters["Dimension"]; }
+    }
+    public DoubleValue Dimension {
+      get { return DimensionParameter.Value; }
+      set { DimensionParameter.Value = value; }
+    }
+    [StorableConstructor]
+    protected SymbolicTimeSeriesPrognosisScaledNormalizedFractionalDistanceEvaluator(bool deserializing) : base(deserializing) { }
+    protected SymbolicTimeSeriesPrognosisScaledNormalizedFractionalDistanceEvaluator(SymbolicTimeSeriesPrognosisScaledNormalizedFractionalDistanceEvaluator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public SymbolicTimeSeriesPrognosisScaledNormalizedFractionalDistanceEvaluator()
+      : base() {
+        Parameters.Add(new ValueParameter<DoubleValue>("Dimension", "The dimension parameter for the fractional distance metric (Sum(x_i-y_i)^(1/d))^d). d=0.5 is equivalent to Euclidian distance.", new DoubleValue(0.5)));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SymbolicTimeSeriesPrognosisScaledNormalizedFractionalDistanceEvaluator(this, cloner);
+    }
+    public override double Evaluate(SymbolicExpressionTree tree, MultiVariateDataAnalysisProblemData problemData, ISymbolicTimeSeriesExpressionInterpreter interpreter, IEnumerable<int> rows, int predictionHorizon, DoubleArray lowerEstimationLimit, DoubleArray upperEstimationLimit) {
+      return Calculate(tree, problemData, interpreter, rows, predictionHorizon, Dimension.Value, lowerEstimationLimit, upperEstimationLimit);
+    }
+
+    public static double Calculate(SymbolicExpressionTree tree, MultiVariateDataAnalysisProblemData problemData, ISymbolicTimeSeriesExpressionInterpreter interpreter, IEnumerable<int> rows, int predictionHorizon, double fractionalDimension, DoubleArray lowerEstimationLimit, DoubleArray upperEstimationLimit) {
+      double[] alpha, beta;
+      double quality;
+
+      Dataset dataset = problemData.Dataset;
+      // calculate scaling parameters based on one-step-predictions
+      IEnumerable<string> selectedTargetVariables = (from item in problemData.TargetVariables
+                                                     where problemData.TargetVariables.ItemChecked(item)
+                                                     select item.Value).ToArray();
+      int dimension = selectedTargetVariables.Count();
+
+      IEnumerable<int> selectedTargetVariableIndexes = (from targetVariable in selectedTargetVariables
+                                                        select dataset.GetVariableIndex(targetVariable)).ToArray();
+      IEnumerable<IEnumerable<double>> oneStepPredictions =
+        interpreter.GetSymbolicExpressionTreeValues(tree, problemData.Dataset, selectedTargetVariables, rows, 1).Cast<IEnumerable<double>>();
+      IEnumerable<IEnumerable<double>> originalValues = from row in rows
+                                                        select (from targetVariableIndex in selectedTargetVariableIndexes
+                                                                select dataset[row, targetVariableIndex]);
+      alpha = new double[dimension];
+      beta = new double[dimension];
+
+      CalculateScalingParameters(originalValues, oneStepPredictions, ref beta, ref alpha);
+
+      // calculate the quality for the full horizon
+      quality = CalculateWithScaling(tree, problemData, interpreter,
+        rows, predictionHorizon, fractionalDimension,
+        lowerEstimationLimit, upperEstimationLimit,
+        beta, alpha);
+      return quality;
+    }
+
+    public static double CalculateWithScaling(SymbolicExpressionTree tree, MultiVariateDataAnalysisProblemData problemData,
+      ISymbolicTimeSeriesExpressionInterpreter interpreter,
+      IEnumerable<int> rows, int predictionHorizon, double fractionalDimension,
+      DoubleArray lowerEstimationLimit, DoubleArray upperEstimationLimit,
+      double[] beta, double[] alpha) {
+      Dataset dataset = problemData.Dataset;
+      IEnumerable<string> selectedTargetVariables = (from targetVariable in problemData.TargetVariables
+                                                     where problemData.TargetVariables.ItemChecked(targetVariable)
+                                                     select targetVariable.Value).ToArray();
+      IEnumerable<int> selectedTargetVariableIndexes = (from targetVariable in selectedTargetVariables
+                                                        select dataset.GetVariableIndex(targetVariable)).ToArray();
+
+      IEnumerable<double[]> estimatedValues =
+        interpreter.GetScaledSymbolicExpressionTreeValues(tree, dataset, selectedTargetVariables,
+        rows, predictionHorizon, beta, alpha);
+
+      IEnumerable<IEnumerable<double>> originalValues = from row in rows
+                                                        from step in Enumerable.Range(0, predictionHorizon)
+                                                        select (from targetVariableIndex in selectedTargetVariableIndexes
+                                                                select dataset[row + step, targetVariableIndex]);
+
+      var evaluator = new OnlineMeanFractionalDistanceEvaluator(fractionalDimension);
+
+      var estimatedValuesEnumerator = estimatedValues.GetEnumerator();
+      var originalValuesEnumerator = originalValues.GetEnumerator();
+      while (originalValuesEnumerator.MoveNext() & estimatedValuesEnumerator.MoveNext()) {
+        IEnumerable<double> original = originalValuesEnumerator.Current;
+        double[] estimated = estimatedValuesEnumerator.Current;
+        for (int i = 0; i < estimated.Length; i++) {
+          if (double.IsNaN(estimated[i])) estimated[i] = upperEstimationLimit[i];
+          else estimated[i] = Math.Min(upperEstimationLimit[i], Math.Max(lowerEstimationLimit[i], estimated[i]));
+        }
+        evaluator.Add(original, estimated);
+      }
+
+      double quality = evaluator.Value;
+      return quality;
+    }
+
+    public static void CalculateScalingParameters(IEnumerable<IEnumerable<double>> originalValues, IEnumerable<IEnumerable<double>> estimatedValues, ref double[] beta, ref double[] alpha) {
+      List<OnlineLinearScalingCalculator> linearScalingCalculators = new List<OnlineLinearScalingCalculator>();
+      // initialize lists
+      int dimension = originalValues.First().Count();
+      for (int i = 0; i < dimension; i++) {
+        linearScalingCalculators.Add(new OnlineLinearScalingCalculator());
+      }
+
+      var estimatedEnumerator = estimatedValues.GetEnumerator();
+      var originalEnumerator = originalValues.GetEnumerator();
+      // foreach row vector in both series
+      while (estimatedEnumerator.MoveNext() & originalEnumerator.MoveNext()) {
+        IEnumerable<double> original = originalEnumerator.Current;
+        IEnumerable<double> estimated = estimatedEnumerator.Current;
+        var originalComponentValuesEnumerator = original.GetEnumerator();
+        var estimatedComponentValuesEnumerator = estimated.GetEnumerator();
+
+        int component = 0;
+        // for each component in both row vectors
+        while (originalComponentValuesEnumerator.MoveNext() & estimatedComponentValuesEnumerator.MoveNext() && component < dimension) {
+          if (IsValidValue(originalComponentValuesEnumerator.Current) && IsValidValue(estimatedComponentValuesEnumerator.Current)) {
+            linearScalingCalculators[component].Add(originalComponentValuesEnumerator.Current, estimatedComponentValuesEnumerator.Current);
+          }
+          component++;
+        }
+        // check if both row vectors are finished
+        if (originalComponentValuesEnumerator.MoveNext() | estimatedComponentValuesEnumerator.MoveNext() || component < dimension) {
+          throw new ArgumentException("Number of elements in original and estimated row vectors does not match.");
+        }
+      }
+
+      // check if both series are finished
+      if (estimatedEnumerator.MoveNext() || originalEnumerator.MoveNext())
+        throw new InvalidOperationException("Number of elements in estimated and original series doesn't match.");
+
+      // get alpha and beta for each component
+      for (int component = 0; component < dimension; component++) {
+        alpha[component] = linearScalingCalculators[component].Alpha;
+        beta[component] = linearScalingCalculators[component].Beta;
+      }
+    }
+
+    private static bool IsValidValue(double d) {
+      return !double.IsInfinity(d) && !double.IsNaN(d) && d > -1.0E07 && d < 1.0E07;  // don't consider very large or very small values for scaling
+    }
+  }
+}
Index: /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Evaluators/SymbolicTimeSeriesPrognosisScaledNormalizedMseEvaluator.cs
===================================================================
--- /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Evaluators/SymbolicTimeSeriesPrognosisScaledNormalizedMseEvaluator.cs	(revision 5274)
+++ /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Evaluators/SymbolicTimeSeriesPrognosisScaledNormalizedMseEvaluator.cs	(revision 5275)
@@ -44,8 +44,15 @@
   public class SymbolicTimeSeriesPrognosisScaledNormalizedMseEvaluator : SymbolicTimeSeriesPrognosisEvaluator {
 
+    [StorableConstructor]
+    protected SymbolicTimeSeriesPrognosisScaledNormalizedMseEvaluator(bool deserializing) : base(deserializing) { }
+    protected SymbolicTimeSeriesPrognosisScaledNormalizedMseEvaluator(SymbolicTimeSeriesPrognosisScaledNormalizedMseEvaluator original, Cloner cloner)
+      : base(original, cloner) {
+    }
     public SymbolicTimeSeriesPrognosisScaledNormalizedMseEvaluator()
       : base() {
     }
-
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SymbolicTimeSeriesPrognosisScaledNormalizedMseEvaluator(this, cloner);
+    }
     public override double Evaluate(SymbolicExpressionTree tree, MultiVariateDataAnalysisProblemData problemData, ISymbolicTimeSeriesExpressionInterpreter interpreter, IEnumerable<int> rows, int predictionHorizon, DoubleArray lowerEstimationLimit, DoubleArray upperEstimationLimit) {
       return Calculate(tree, problemData, interpreter, rows, predictionHorizon, lowerEstimationLimit, upperEstimationLimit);
Index: /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SingleObjectiveSymbolicTimeSeriesPrognosisProblem.cs
===================================================================
--- /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SingleObjectiveSymbolicTimeSeriesPrognosisProblem.cs	(revision 5274)
+++ /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SingleObjectiveSymbolicTimeSeriesPrognosisProblem.cs	(revision 5275)
@@ -87,4 +87,8 @@
     [StorableConstructor]
     protected SingleObjectiveSymbolicTimeSeriesPrognosisProblem(bool deserializing) : base(deserializing) { }
+    protected SingleObjectiveSymbolicTimeSeriesPrognosisProblem(SingleObjectiveSymbolicTimeSeriesPrognosisProblem original, Cloner cloner)
+      : base(original, cloner) {
+        AttachEventHandlers();
+    }
     public SingleObjectiveSymbolicTimeSeriesPrognosisProblem()
       : base() {
@@ -102,12 +106,10 @@
 
     [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserializationHook() {
+    private void AfterDeserialization() {
       AttachEventHandlers();
     }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      SingleObjectiveSymbolicTimeSeriesPrognosisProblem clone = (SingleObjectiveSymbolicTimeSeriesPrognosisProblem)base.Clone(cloner);
-      clone.AttachEventHandlers();
-      return clone;
+      return new SingleObjectiveSymbolicTimeSeriesPrognosisProblem(this, cloner);
     }
 
Index: /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesExpressionInterpreter.cs
===================================================================
--- /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesExpressionInterpreter.cs	(revision 5274)
+++ /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesExpressionInterpreter.cs	(revision 5275)
@@ -116,7 +116,14 @@
       get { return false; }
     }
-
+    [StorableConstructor]
+    protected SymbolicTimeSeriesExpressionInterpreter(bool deserializing) : base(deserializing) { }
+    protected SymbolicTimeSeriesExpressionInterpreter(SymbolicTimeSeriesExpressionInterpreter original, Cloner cloner)
+      : base(original, cloner) {
+    }
     public SymbolicTimeSeriesExpressionInterpreter()
       : base() {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SymbolicTimeSeriesExpressionInterpreter(this, cloner);
     }
     #region ITimeSeriesExpressionInterpreter Members
Index: /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesPrognosisGrammar.cs
===================================================================
--- /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesPrognosisGrammar.cs	(revision 5274)
+++ /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesPrognosisGrammar.cs	(revision 5275)
@@ -38,9 +38,18 @@
     // for persistence
     private SymbolicTimeSeriesPrognosisGrammar() : this(1) { }
-
+    [StorableConstructor]
+    protected SymbolicTimeSeriesPrognosisGrammar(bool deserializing) : base(deserializing) { }
+    protected SymbolicTimeSeriesPrognosisGrammar(SymbolicTimeSeriesPrognosisGrammar original, Cloner cloner)
+      : base(original, cloner) {
+        dimension = original.dimension;
+    }
     public SymbolicTimeSeriesPrognosisGrammar(int dimension)
       : base() {
       this.dimension = dimension;
       Initialize();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SymbolicTimeSeriesPrognosisGrammar(this, cloner);
     }
 
@@ -129,11 +138,5 @@
           }
       }
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      SymbolicTimeSeriesPrognosisGrammar clone = (SymbolicTimeSeriesPrognosisGrammar)base.Clone(cloner);
-      clone.dimension = this.dimension;
-      return clone;
-    }
+    }   
   }
 }
Index: /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesPrognosisModel.cs
===================================================================
--- /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesPrognosisModel.cs	(revision 5274)
+++ /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesPrognosisModel.cs	(revision 5275)
@@ -47,11 +47,18 @@
     [StorableConstructor]
     protected SymbolicTimeSeriesPrognosisModel(bool deserializing) : base(deserializing) { }
-
+    protected SymbolicTimeSeriesPrognosisModel(SymbolicTimeSeriesPrognosisModel original, Cloner cloner)
+      : base(original, cloner) {
+        tree = cloner.Clone(original.tree);
+        interpreter = cloner.Clone(original.interpreter);
+    }
     public SymbolicTimeSeriesPrognosisModel() { }
-
     public SymbolicTimeSeriesPrognosisModel(ISymbolicTimeSeriesExpressionInterpreter interpreter, SymbolicExpressionTree tree) {
       this.tree = tree;
       this.interpreter = interpreter;
 
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SymbolicTimeSeriesPrognosisModel(this, cloner);
     }
 
@@ -70,10 +77,4 @@
     #endregion
 
-    public override IDeepCloneable Clone(Cloner cloner) {
-      SymbolicTimeSeriesPrognosisModel clone = (SymbolicTimeSeriesPrognosisModel)base.Clone(cloner);
-      clone.tree = (SymbolicExpressionTree)cloner.Clone(tree);
-      clone.interpreter = (ISymbolicTimeSeriesExpressionInterpreter)cloner.Clone(interpreter);
-      return clone;
-    }
   }
 }
Index: /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesPrognosisProblem.cs
===================================================================
--- /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesPrognosisProblem.cs	(revision 5274)
+++ /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesPrognosisProblem.cs	(revision 5275)
@@ -161,4 +161,11 @@
     [StorableConstructor]
     protected SymbolicTimeSeriesPrognosisProblem(bool deserializing) : base(deserializing) { }
+    protected SymbolicTimeSeriesPrognosisProblem(SymbolicTimeSeriesPrognosisProblem original, Cloner cloner)
+      : base(original, cloner) {
+      operators = original.operators.Select(x => (IOperator)cloner.Clone(x)).ToList();
+      grammar = (SymbolicTimeSeriesPrognosisGrammar)cloner.Clone(original.grammar);
+      RegisterParameterEvents();
+      RegisterParameterValueEvents();
+    }
     public SymbolicTimeSeriesPrognosisProblem()
       : base() {
@@ -188,5 +195,5 @@
 
     [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserializationHook() {
+    private void AfterDeserialization() {
       // BackwardsCompatibility3.3
       #region Backwards compatible code (remove with 3.4)
@@ -198,10 +205,5 @@
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      SymbolicTimeSeriesPrognosisProblem clone = (SymbolicTimeSeriesPrognosisProblem)base.Clone(cloner);
-      clone.operators = operators.Select(x => (IOperator)cloner.Clone(x)).ToList();
-      clone.grammar = (SymbolicTimeSeriesPrognosisGrammar)cloner.Clone(grammar);
-      clone.RegisterParameterEvents();
-      clone.RegisterParameterValueEvents();
-      return clone;
+      return new SymbolicTimeSeriesPrognosisProblem(this, cloner);
     }
 
Index: /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesPrognosisSolution.cs
===================================================================
--- /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesPrognosisSolution.cs	(revision 5274)
+++ /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesPrognosisSolution.cs	(revision 5275)
@@ -54,5 +54,13 @@
     [StorableConstructor]
     protected SymbolicTimeSeriesPrognosisSolution(bool deserializing) : base(deserializing) { }
-
+    protected SymbolicTimeSeriesPrognosisSolution(SymbolicTimeSeriesPrognosisSolution original, Cloner cloner)
+      : base(original, cloner) {
+      problemData = (MultiVariateDataAnalysisProblemData)cloner.Clone(original.problemData);
+      model = (SymbolicTimeSeriesPrognosisModel)cloner.Clone(original.model);
+      horizon = original.horizon;
+      conditionalEvaluationVariable = original.conditionalEvaluationVariable;
+      lowerEstimationLimit = (double[])original.lowerEstimationLimit.Clone();
+      upperEstimationLimit = (double[])original.upperEstimationLimit.Clone();
+    }
     public SymbolicTimeSeriesPrognosisSolution() {
       horizon = 1;
@@ -68,7 +76,9 @@
       this.upperEstimationLimit = (double[])upperEstimationLimit.Clone();
     }
-
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SymbolicTimeSeriesPrognosisSolution(this, cloner);
+    }
     [StorableHook(HookType.AfterDeserialization)]
-    private void Initialize() {
+    private void AfterDeserialization() {
       if (problemData != null)
         RegisterProblemDataEvents();
@@ -206,14 +216,4 @@
 
 
-    public override IDeepCloneable Clone(Cloner cloner) {
-      SymbolicTimeSeriesPrognosisSolution clone = (SymbolicTimeSeriesPrognosisSolution)base.Clone(cloner);
-      clone.problemData = (MultiVariateDataAnalysisProblemData)cloner.Clone(problemData);
-      clone.model = (SymbolicTimeSeriesPrognosisModel)cloner.Clone(model);
-      clone.horizon = horizon;
-      clone.conditionalEvaluationVariable = conditionalEvaluationVariable;
-      clone.lowerEstimationLimit = (double[])lowerEstimationLimit.Clone();
-      clone.upperEstimationLimit = (double[])upperEstimationLimit.Clone();
-      return clone;
-    }
 
     private IEnumerable<double[]> ApplyEstimationLimits(IEnumerable<double[]> values) {
Index: /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/DerivativeVariable.cs
===================================================================
--- /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/DerivativeVariable.cs	(revision 5274)
+++ /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/DerivativeVariable.cs	(revision 5275)
@@ -47,4 +47,11 @@
       set { maxLag = value; }
     }
+    [StorableConstructor]
+    protected DerivativeVariable(bool deserializing) : base(deserializing) { }
+    protected DerivativeVariable(DerivativeVariable original, Cloner cloner)
+      : base(original, cloner) {
+        minLag = original.minLag;
+        maxLag = original.maxLag;
+    }
     public DerivativeVariable()
       : base("DerivativeVariable", "Represents an differentiated variable value with a time offset.") {
@@ -57,8 +64,5 @@
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      DerivativeVariable clone = (DerivativeVariable)base.Clone(cloner);
-      clone.minLag = minLag;
-      clone.maxLag = maxLag;
-      return clone;
+      return new DerivativeVariable(this, cloner);
     }
   }
Index: /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/DerivativeVariableTreeNode.cs
===================================================================
--- /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/DerivativeVariableTreeNode.cs	(revision 5274)
+++ /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/DerivativeVariableTreeNode.cs	(revision 5275)
@@ -44,8 +44,9 @@
     private DerivativeVariableTreeNode() { }
 
-    // copy constructor
-    private DerivativeVariableTreeNode(DerivativeVariableTreeNode original)
-      : base(original) {
-      lag = original.lag;
+    [StorableConstructor]
+    protected DerivativeVariableTreeNode(bool deserializing) : base(deserializing) { }
+    protected DerivativeVariableTreeNode(DerivativeVariableTreeNode original, Cloner cloner)
+      : base(original, cloner) {
+        lag = original.lag;
     }
 
@@ -69,6 +70,6 @@
 
 
-    public override object Clone() {
-      return new DerivativeVariableTreeNode(this);
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DerivativeVariableTreeNode(this, cloner);
     }
 
Index: /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/IntegratedVariable.cs
===================================================================
--- /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/IntegratedVariable.cs	(revision 5274)
+++ /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/IntegratedVariable.cs	(revision 5275)
@@ -47,4 +47,11 @@
       set { maxLag = value; }
     }
+    [StorableConstructor]
+    protected IntegratedVariable(bool deserializing) : base(deserializing) { }
+    protected IntegratedVariable(IntegratedVariable original, Cloner cloner)
+      : base(original, cloner) {
+        minLag = original.minLag;
+        maxLag = original.maxLag;
+    }
     public IntegratedVariable()
       : base("IntegratedVariable", "Represents an integrated variable value with a time offset.") {
@@ -57,8 +64,5 @@
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      IntegratedVariable clone = (IntegratedVariable)base.Clone(cloner);
-      clone.minLag = minLag;
-      clone.maxLag = maxLag;
-      return clone;
+      return new IntegratedVariable(this, cloner);
     }
   }
Index: /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/IntegratedVariableTreeNode.cs
===================================================================
--- /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/IntegratedVariableTreeNode.cs	(revision 5274)
+++ /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/IntegratedVariableTreeNode.cs	(revision 5275)
@@ -50,8 +50,8 @@
 
     private IntegratedVariableTreeNode() { }
-
-    // copy constructor
-    private IntegratedVariableTreeNode(IntegratedVariableTreeNode original)
-      : base(original) {
+    [StorableConstructor]
+    protected IntegratedVariableTreeNode(bool deserializing) : base(deserializing) { }
+    protected IntegratedVariableTreeNode(IntegratedVariableTreeNode original, Cloner cloner)
+      : base(original, cloner) {
       minTimeOffset = original.minTimeOffset;
       maxTimeOffset = original.maxTimeOffset;
@@ -77,10 +77,7 @@
       maxTimeOffset = Math.Min(Symbol.MaxLag, Math.Max(minTimeOffset, maxTimeOffset + random.Next(-1, 2)));
     }
-
-
-    public override object Clone() {
-      return new IntegratedVariableTreeNode(this);
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new IntegratedVariableTreeNode(this, cloner);
     }
-
     public override string ToString() {
       return Weight.ToString("E4") + " I(" + VariableName +
Index: /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/MovingAverage.cs
===================================================================
--- /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/MovingAverage.cs	(revision 5274)
+++ /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/MovingAverage.cs	(revision 5275)
@@ -47,4 +47,11 @@
       set { maxLag = value; }
     }
+    [StorableConstructor]
+    protected MovingAverage(bool deserializing) : base(deserializing) { }
+    protected MovingAverage(MovingAverage original, Cloner cloner)
+      : base(original, cloner) {
+      minLag = original.minLag;
+      maxLag = original.maxLag;
+    }
     public MovingAverage()
       : base("MovingAverage", "Represents a moving average of a variable value with a time offset.") {
@@ -57,8 +64,5 @@
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      MovingAverage clone = (MovingAverage)base.Clone(cloner);
-      clone.minLag = minLag;
-      clone.maxLag = maxLag;
-      return clone;
+      return new MovingAverage(this, cloner);
     }
   }
Index: /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/MovingAverageTreeNode.cs
===================================================================
--- /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/MovingAverageTreeNode.cs	(revision 5274)
+++ /branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/Symbols/MovingAverageTreeNode.cs	(revision 5275)
@@ -50,8 +50,8 @@
 
     private MovingAverageTreeNode() { }
-
-    // copy constructor
-    private MovingAverageTreeNode(MovingAverageTreeNode original)
-      : base(original) {
+    [StorableConstructor]
+    protected MovingAverageTreeNode(bool deserializing) : base(deserializing) { }
+    protected MovingAverageTreeNode(MovingAverageTreeNode original, Cloner cloner)
+      : base(original, cloner) {
       minTimeOffset = original.minTimeOffset;
       maxTimeOffset = original.maxTimeOffset;
@@ -79,8 +79,7 @@
 
 
-    public override object Clone() {
-      return new MovingAverageTreeNode(this);
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MovingAverageTreeNode(this, cloner);
     }
-
     public override string ToString() {
       return Weight.ToString("E4") + " MA(" + VariableName +
